<?php
 //http://stackoverflow.com/questions/18382740/cors-not-working-php
    if (isset($_SERVER['HTTP_ORIGIN'])) {
        header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
        header('Access-Control-Allow-Credentials: true');
        header('Access-Control-Max-Age: 86400');    // cache for 1 day
        //header("Access-Control-Allow-Origin: *"); 
    }
 
    // Access-Control headers are received during OPTIONS requests
    if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
 
        if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
            header("Access-Control-Allow-Methods: GET, POST, OPTIONS");         
 
        if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
            header("Access-Control-Allow-Headers:        {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");
 
        exit(0);
    }
 

error_reporting(E_ALL | E_STRICT);
ini_set("log_errors", 1);
ini_set("error_log", "/var/www/html/log/msg.log");

error_log("api: start0");

$data=1;

    $postdata = file_get_contents("php://input");
    if (isset($postdata)) {
        $request = json_decode($postdata);
        $woundPointsList = $request->woundPoints;
        $otherPointsList = $request->otherPoints;
        $imageName = $request->imageName;

        error_log("api: start  imageName=".$imageName);

        if ($woundPointsList != "") {

            $inputFilename="uploads/".$imageName .".jpg";
            $inputFileOption="-i ".$inputFilename;
            $otherPointsOption="-s ".$otherPointsList;
            $woundPointsOption="-w ".$woundPointsList;
            $outputBitmapFilename="results/".$imageName.".png";
            $outputInfoFilename="results/".$imageName.".txt";
            $outputOptions="--om ".$outputBitmapFilename." --ot ".$outputInfoFilename; // --oi results/".$imageName."_annot.png
            
            if ($otherPointsList == "") {
                error_log("api: warning: no other points");
                $otherPointsOption="";
            }

            $path = "/usr/share/Pack201802B/build/src/urgoeye";

            
            $arguments=$inputFileOption." ".$otherPointsOption." ".$woundPointsOption." ".$outputOptions;
            
            $retour=[];

            $cmdFilename="uploads/".$imageName."_cmd.txt";
            file_put_contents($cmdFilename, "$path $arguments\n");
            
            $retval=1;
            exec("$path $arguments 2>&1", $retArr, $retVal);

            $outputFilename="results/".$imageName."_output.txt";
        	file_put_contents($outputFilename, $retArr);
            file_put_contents($outputFilename, "\nretour=".$retVal."\n", FILE_APPEND);

            $data = $retVal;
            if ($retVal == 0) {
                error_log("api: OK");
            }
	    else {
	    	error_log("api: error: ".$retVal); 
	    }            

            error_log("api: end");
        }
        else {
            error_log("api: ERROR: Empty wound points lists parameter!");
            $data = 5; //invalid wound points error
        }
    }
    else {
        error_log("api: ERROR: No data received!");
        $data = 9; //Unknown error
    }

error_log("api: end0");

echo $data;
?>
